'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.loadmaskReducer = loadmaskReducer;

var _constants = require('../shared/constants');

var _immutable = require('immutable');

var $$initialState = (0, _immutable.fromJS)({
  showLoadmask: []
});

// NOTE: Instances of Immutable types are notated with the `$$`

function loadmaskReducer() {
  var $$state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : $$initialState;

  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      type = _ref.type;

  switch (type) {
    case _constants.SHOW_LOADMASK:
      return $$state.merge({
        showLoadmask: $$state.get('showLoadmask').push(new Date())
      });

    case _constants.HIDE_LOADMASK:
      return $$state.merge({
        showLoadmask: $$state.get('showLoadmask').shift()
      });

    default:
      return $$state;
  }
}